/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.1.17494 at Mon Apr 26 09:44:54 PM CEST 2010
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/******************************************************************

  External task for the example Simple.
  threaded integration version for all OS.

*******************************************************************/

#include "scttypes.h"
#include "simple.ifc"

/****+***************************************************************
     Simple example: MyExtTask
********************************************************************/

void MyExtTask1 XPP(( void ))
{
  xSignalNode yInputSignalPtr, yOutputSignalPtr;
  xPrsIdNode MyPrsId;
  SDL_PId MyPId1;
  int i, param;

printf("Task1 started\n");

  /* Get an SDL_PId representing the External Task in the SDL system */
   MyPId1 = xThreadedRegExtTask();

  for(i=1;i<=1;i++) {
    if (i==1) {
      yOutputSignalPtr = xGetSignal(go,pr1[1],MyPId1);
      THREADED_ASSIGN_SDL_SIG_PARAMS(yOutputSignalPtr,go,1,startinstance1);
    } else {
      yOutputSignalPtr = xGetSignal(go,pr1[2],MyPId1);
      THREADED_ASSIGN_SDL_SIG_PARAMS(yOutputSignalPtr,go,1,startinstance2);
    }
    SDL_Output(yOutputSignalPtr, xSigPrioPar(xDefaultPrioSignal) (xIdNode *)0 );
  }

  for(i=1;i<=1;i++) {
    yInputSignalPtr = 0;
    yInputSignalPtr = xThreadedReceiveSDLSig(MyPId1);
    if(yInputSignalPtr->NameNode == ok) {
      THREADED_GET_SDL_SIG_PARAM(yInputSignalPtr,go,1,param);
      printf("Ok received in MyExtTask1 with parameter = %lu\n",
             param);
    }
    xReleaseSignalNotPara(&yInputSignalPtr);
  }
  THREADED_SUSPEND_THREAD
}

void MyExtTask2 XPP(( void ))
{
  xSignalNode yInputSignalPtr, yOutputSignalPtr;
  xPrsIdNode MyPrsId;
  SDL_PId MyPId;
  int i, param;
printf("Task2 started\n");

  MyPId = xThreadedRegExtTask();

  for(i=1;i<=1;i++) {
    if (i==1) {
      yOutputSignalPtr = xGetSignal(go,pr1[2],MyPId);
      THREADED_ASSIGN_SDL_SIG_PARAMS(yOutputSignalPtr,go,1,startinstance2);
    } else {
      yOutputSignalPtr = xGetSignal(go,pr1[2],MyPId);
      THREADED_ASSIGN_SDL_SIG_PARAMS(yOutputSignalPtr,go,1,startinstance2);
    }
    SDL_Output(yOutputSignalPtr, xSigPrioPar(xDefaultPrioSignal) (xIdNode *)0 );
  }

  for(i=1;i<=1;i++) {
    yInputSignalPtr = 0;
    yInputSignalPtr = xThreadedReceiveSDLSig(MyPId);
    if(yInputSignalPtr->NameNode == ok) {

      THREADED_GET_SDL_SIG_PARAM(yInputSignalPtr,go,1,param);
      printf("Ok received in MyExtTask2 with parameter = %lu\n",
             param);
    }
    xReleaseSignalNotPara(&yInputSignalPtr);
  }
  THREADED_SUSPEND_THREAD
}
