/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.1.17494 at Mon Apr 26 09:44:53 PM CEST 2010
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+HDR*/
/*
+------------------------------------------------------------------------------+
#  Modulname: ml_mem.h
+------------------------------------------------------------------------------+
*/
/*-HDR*/


#ifndef __ML_MEM_H_
#define __ML_MEM_H_

#ifdef XSYSID
  /*
  ** If partitioning is used, then the ml_mem module 
  ** cannot be used
  */
  #error "Error_ml_mem_c_cannot_be_used_for_partitioning"
#endif /* ... XSYSID */


#ifdef XMK_USE_SDL_MEM

  extern void   xmk_MemInit          (void *, void *);
  extern size_t xmk_EvaluateExp2Size ( size_t rl );
  extern void * xmk_Malloc           ( size_t ) ;
  extern void   xmk_Free             ( void *) ;
  extern void * xmk_Calloc           ( size_t, size_t ) ;
  
  #ifdef XMK_USE_memshrink
    extern void  xmk_Memshrink       ( void *, size_t ) ;
  #endif

  #if defined(XMK_ADD_PROFILE) && defined(XMK_SYSTEM_INFO)
    extern size_t xmk_GetOccupiedMem ( void );
    extern size_t xmk_GetFreeMem     ( void );
    extern int    xmk_CleanPool      ( void );
  #endif

  #ifdef XMK_USE_memset
    /*
    ** the xmk_OPT_INT below may be defined as char only, if the value
    ** is less then 256 in any case ! 
    */
    extern void * memset      ( void *, xmk_OPT_INT, size_t ) ;
  #endif

  #ifdef XMK_USE_memcpy
    extern void * memcpy      ( void *, XCONST void *, size_t ) ;
  #endif

  #ifdef XMK_USE_strlen
    extern size_t strlen      (XCONST char *);
  #endif

  #ifdef XMK_USE_strcpy
    extern char * strcpy      ( char *, XCONST char * );
  #endif

  #ifdef XMK_USE_strcmp
    extern int strcmp         (XCONST char *, XCONST char *);
  #endif

#endif /* ... XMK_USE_SDL_MEM */

#endif /* ... __ML_MEM_H */
