/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.1.17494 at Mon Apr 26 09:44:53 PM CEST 2010
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __coderucf_h
#define __coderucf_h

#include "cucf.h"

/* Compile switches backward compatibility */

#if defined(CODER_BER_CONTENTS_OCTETS)
#define CODER_BER_CONSTRUCTED_LENGTH CODER_BER_CONTENTS_OCTETS
#endif



/* BMS backward compatibility */

#define SmlBuf  bms_SmallBuffer
#define SML_BUF bms_SmallBuffer

#define Direct
#define Reverse

#undef BufInitBuf
#define BufInitBuf(b, buftype, dirmode) \
  BaseBufInitBuf(&b, buftype, NULL)

#define BufInDirectMode(b)   1
#define BufInReverseMode(b)  0

/* Error Codes backward compatibility */

/* CUCF_ERROR_BEGIN: this line must not changed */

#define ec_SMLBUF_READ_ERROR                 ec_BUF_NoMoreDataForRead

#define ec_UNKNOWN_TYPE_CLASS                ec_INT_UnsupportedType

#define ec_BER_WRONG_UNUSED_BITS             ec_DEC_WrongUnusedBits
#define ec_BER_WRONG_REAL_VALUE              ec_DEC_WrongRealPrefix
#define ec_BER_UNSUPPORTED_REAL_BASE         ec_DEC_UnsupportedRealBase
#define ec_BER_UNSUPPORTED_REAL_DECIMAL_ENC  ec_DEC_UnsupportedRealDecimalEncoding
#define ec_BER_WRONG_ALTERNATIVE_TAG         ec_DEC_UnknownAlternative
#define ec_BER_WRONG_COMPONENT_TAG           ec_DEC_UnknownComponent
#define ec_BER_OPEN_TABLE_ID_NOT_PRESENT     ec_DEC_NoOpenId
#define ec_BER_WRONG_OPEN_TABLE_ID           ec_DEC_UnknownObject

#define ec_PER_WRONG_REAL_VALUE              ec_DEC_WrongRealPrefix
#define ec_PER_UNSUPPORTED_REAL_BASE         ec_DEC_UnsupportedRealBase
#define ec_PER_UNSUPPORTED_REAL_DECIMAL_ENC  ec_DEC_UnsupportedRealDecimalEncoding
#define ec_PER_WRONG_FRAGMENTATION           ec_DEC_WrongConstructedLengthPrefix
#define ec_PER_OPEN_TABLE_ID_NOT_PRESENT     ec_DEC_NoOpenId
#define ec_PER_WRONG_OPEN_TABLE_ID           ec_DEC_UnknownObject

/* CUCF_ERROR_END: this line must not changed */

#endif /* __coderucf_h */
