/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.1.17494 at Mon Apr 26 09:44:53 PM CEST 2010
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __ber_h
#define __ber_h

#ifndef CODER_REMOVE_BER

#ifdef CODER_BER_CONSTRUCTED
#ifndef CODER_BER_CONSTRUCTED_LENGTH
#define CODER_BER_CONSTRUCTED_LENGTH 1000
#endif
#endif

#ifndef CODER_BER_BOOLEAN_VALUE
#define CODER_BER_BOOLEAN_VALUE 255
#endif

#if (CODER_BER_BOOLEAN_VALUE < 1) || (CODER_BER_BOOLEAN_VALUE > 255)
#error Compile switch error: CODER_BER_BOOLEAN_VALUE must be greater than 0 and less than 256
#endif

#if defined(CODER_BER_REAL_FACTOR_1)
#define CUCF_BER_REAL_FACTOR 1
#elif defined(CODER_BER_REAL_FACTOR_2)
#define CUCF_BER_REAL_FACTOR 2
#elif defined(CODER_BER_REAL_FACTOR_3)
#define CUCF_BER_REAL_FACTOR 3
#else /* CODER_BER_REAL_FACTOR_0 */
#define CUCF_BER_REAL_FACTOR 0
#endif

#define BER_ENCODE(c, type, val) BEREncode(c, type, val)
#define BER_DECODE(c, type, val) BERDecode(c, type, val)

int BEREncode(tCoder* Coder, tASN1TypeInfo* Type, void* Val);
int BERDecode(tCoder* Coder, tASN1TypeInfo* Type, void* Val);

#endif /* !CODER_REMOVE_BER */

#endif /* __ber_h */
