/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.1.17494 at Mon Apr 26 09:44:53 PM CEST 2010
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __mms_h
#define __mms_h

/* Memory management system configuration */

#if defined(CODER_MMS_USER)

#include "mms_user.h"

#ifdef USER_BMS_ALLOC_FUNC
#define BMS_ALLOC(coder, size, type)     USER_BMS_ALLOC_FUNC(coder, size, type)
#endif
#ifdef USER_BMS_FREE_FUNC
#define BMS_FREE(coder, ptr, size, type) USER_BMS_FREE_FUNC(coder, ptr, size, type)
#endif

#define CUCF_ALLOC(size, type)           USER_ALLOC_FUNC(size, type)
#define CUCF_FREE(ptr, size, type)       USER_FREE_FUNC(ptr, size, type)

#elif defined(CODER_MMS_SDT)

#include "scttypes.h"

#define CUCF_ALLOC(size, type)           XALLOC(size, type)
#define CUCF_FREE(ptr, size, type)       XFREE((void**)&(ptr), size)

#else /* CODER_MMS_DEFAULT */

#define CUCF_ALLOC(size, type)           malloc(size)
#define CUCF_FREE(ptr, size, type)       free(ptr)
#endif

#ifndef BMS_ALLOC
#define BMS_ALLOC(coder, size, type)     CUCF_ALLOC(size, type)
#endif
#ifndef BMS_FREE
#define BMS_FREE(coder, ptr, size, type) CUCF_FREE(ptr, size, type)
#endif

/* Memory handling */

void MMSRelease(tCoder* Coder);

void  MMSFree(tCoder* Coder, void* Ptr, size_t Size);
void* MMSAlloc(tCoder* Coder, size_t Size);

#define CUCFFree(coder, ptr, size, type) MMSFree(coder, ptr, size)
#define CUCFAlloc(coder, size, type)     MMSAlloc(coder, size)

#endif /* __mms_h */
