#
#   sdt.profile
#
#Licensed Materials - Property of IBM
#
#(c) Copyright IBM Corporation 1993, 2010. All Rights Reserved.
#
#U.S. Government Users Restricted Rights:  
#Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# ##############################################################################
#
# This script can't be run stand-alone is used from telelogic.profile
#
# Check if binary directory is installed for SDT
if [ -x $telelogicbin/sdtmsce ]; then
	sdtbin=$telelogic/bin/${hosttype}bin
	sdtdir=$telelogic/sdt/sdtdir/${hosttype}sdtdir
	export sdtbin sdtdir
else
  	echo "(SDT): Unable to locate binary directory for this architecture."
    	echo "(SDT): Please contact your system administrator."
fi
