/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.1.17494 at Mon Apr 26 09:44:53 PM CEST 2010
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/*+MHDR*/
/*

+------------------------------------------------------------------------------+
#  Modulname: mk_queu.h
+------------------------------------------------------------------------------+
*/
/*-MHDR*/



#ifndef __MK_QUEU_H_
#define __MK_QUEU_H_

#ifdef XSYSID
  /*
  ** If partitioning is used, then redefine function names
  ** to make them unique in the whole system (over
  ** all partitions)
  */
  #define xmk_InitQueue                       XMAKENAME(XSYSID,InitQueue)
  #define xmk_FirstSignal                     XMAKENAME(XSYSID,FirstSignal)
  #define xmk_NextSignal                      XMAKENAME(XSYSID,NextSignal)
  #define xmk_InsertSignal                    XMAKENAME(XSYSID,InsertSignal)
  #define xmk_RemoveCurrentSignal             XMAKENAME(XSYSID,RemoveCurrentSignal)
  #define xmk_RemoveSignalBySignalID          XMAKENAME(XSYSID,RemoveSignalBySignalID)
  #define xmk_RemoveSignalsByProcessID        XMAKENAME(XSYSID,RemoveSignalsByProcessID)
  #define xmk_AllocSignal                     XMAKENAME(XSYSID,AllocSignal)
  #define xmk_FreeSignal                      XMAKENAME(XSYSID,FreeSignal)
  #define xmk_TestAndSetSaveState             XMAKENAME(XSYSID,TestAndSetSaveState)
  #define xmk_SaveSignalsOnly                 XMAKENAME(XSYSID,SaveSignalsOnly )
  #define xmk_QueueEmpty                      XMAKENAME(XSYSID,QueueEmpty )
  #define xmk_QueryQueue                      XMAKENAME(XSYSID,QueryQueue )
#endif /* ... XSYSID */


extern void          xmk_InitQueue ( void );

extern xmk_T_MESSAGE xmk_RAM_ptr xmk_FirstSignal ( void );

extern xmk_T_MESSAGE xmk_RAM_ptr xmk_NextSignal ( void );

extern void          xmk_InsertSignal ( xmk_T_MESSAGE xmk_RAM_ptr );

extern void          xmk_RemoveCurrentSignal ( void );

#ifdef XMK_USED_TIMER
  #undef ADD_PAR
  #ifdef XMK_USED_TIMER_WITH_PARAMS
    #define ADD_PAR          ,SDL_Integer
  #else
    #define ADD_PAR 
  #endif

  extern xmk_T_BOOL  xmk_IsTimerInQueue ( xmk_T_SIGNAL    ADD_PAR );
#endif

extern xmk_T_MESSAGE xmk_RAM_ptr xmk_AllocSignal ( void );

extern void          xmk_FreeSignal ( xmk_T_MESSAGE xmk_RAM_ptr);

extern xmk_T_BOOL    xmk_RemoveSignalsByProcessID ( xPID );

#if defined(XMK_ADD_PROFILE) || defined(XMK_ADD_CQUERY_TIMER)
  #ifdef XMK_USED_TIMER_WITH_PARAMS
    extern int   xmk_RemoveTimerWithParameter ( xmk_T_SIGNAL, SDL_Integer );
  #else
    extern int   xmk_RemoveSignalBySignalID ( xmk_T_SIGNAL );
  #endif 
#else
  #ifdef XMK_USED_TIMER_WITH_PARAMS
    extern void  xmk_RemoveTimerWithParameter ( xmk_T_SIGNAL, SDL_Integer );
  #else
    extern void  xmk_RemoveSignalBySignalID ( xmk_T_SIGNAL );
  #endif 
#endif /* ... defined(XMK_ADD_PROFILE) || defined(XMK_ADD_CQUERY_TIMER) */

extern xmk_T_BOOL   xmk_TestAndSetSaveState ( xmk_T_STATE );

#if defined (XMK_USED_SAVE) && defined (XMK_USE_INTERNAL_QUEUE_HANDLING)
  extern xmk_T_BOOL     xmk_SaveSignalsOnly ( void );
#endif

/* Manual scaling */
extern xmk_T_BOOL     xmk_QueueEmpty ( void );

#if defined(XMK_SYSTEM_INFO) || (defined(XMK_USE_DEBUGGING)\
    && defined(XMK_ADD_CQUERY_QUEUE))
extern xmk_T_BOOL xmk_QueueEmpty ( void );
#endif

#if (defined(XFREESIGNALFUNCS) || defined(XMK_USERFREESIGNALFUNC))\
    && defined (XMK_USED_SIGNAL_WITH_DYN_PARAMS)
 
  extern void xmk_ReleaseSignalParameter    (xmk_T_MESSAGE xmk_RAM_ptr);
#endif

#endif
