/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.1.17494 at Mon Apr 26 09:44:53 PM CEST 2010
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf.h"

#if !defined(CODER_BMS_SMALLBUF) && !defined(CODER_BMS_USERBUF)
/**************************************************
 *
 * NAME: BaseBufInitBuf
 *
 *
 */

int
BaseBufInitBuf(tCoder** Coder, tBMSBufType BufType)
{
#ifdef CODER_DEBUG_BMS
  fprintf(stdout, "BaseBufInitBuf\n");
#endif

#ifdef CODER_BMS_TINY
  if (*Coder == NULL) {
    *Coder = (tCoder*)BMS_ALLOC(*Coder, sizeof(tCoder), 0);
    MEMORY_ERROR_HANDLER_EXP(*Coder == NULL, *Coder, return ec_MEM_NotEnoughMemory, ec_MEM_NotEnoughMemory, NO_ARGS);
    (*Coder)->IsAssigned = 0;
  } else {
    (*Coder)->IsAssigned = 1;
  }
#else
  *Coder = (tCoder*)BMS_ALLOC(*Coder, sizeof(tCoder), 0);
  MEMORY_ERROR_HANDLER_EXP(*Coder == NULL, *Coder, return ec_MEM_NotEnoughMemory, ec_MEM_NotEnoughMemory, NO_ARGS);
#endif
    
  switch(BufType)
    {
#ifndef CODER_REMOVE_SMALLBUF
     case bms_SmallBuffer:
       (*Coder)->BMS.BMSBuffer = SmallBuffer;
       break;
#endif
#ifdef CODER_USE_USERBUF
    case bms_UserBuffer:
      (*Coder)->BMS.BMSBuffer = UserBuffer;
      break;
#endif
    default:
      (*Coder)->EMS.IsAssigned = 0;
      BASEBUF_ERROR_HANDLER(*Coder, return ec_BUF_WrongBufferType, ec_BUF_WrongBufferType, NO_ARGS);
    }
  return (*Coder)->BMS.BMSBuffer.initBuf(Coder);
}

/**************************************************
 *
 * NAME: BaseBufInitBufWithMemory
 *
 *
 */

int
BaseBufInitBufWithMemory(tCoder** Coder, tBMSBufType BufType, tBMSUserMemory* UserMemory)
{
#ifdef CODER_DEBUG_BMS
  fprintf(stdout, "BaseBufInitBufWithMemory\n");
#endif

  if (UserMemory == NULL)
    return ec_BUF_NullPtrToUserMemory;

#ifdef CODER_BMS_TINY
  if (*Coder == NULL) {
    *Coder = (tCoder*)BMS_ALLOC(*Coder, sizeof(tCoder), 0);
    MEMORY_ERROR_HANDLER_EXP(*Coder == NULL, *Coder, return ec_MEM_NotEnoughMemory, ec_MEM_NotEnoughMemory, NO_ARGS);
    (*Coder)->IsAssigned = 0;
  } else {
    (*Coder)->IsAssigned = 1;
  }
#else
  *Coder = (tCoder*)BMS_ALLOC(*Coder, sizeof(tCoder), 0);
  MEMORY_ERROR_HANDLER_EXP(*Coder == NULL, *Coder, return ec_MEM_NotEnoughMemory, ec_MEM_NotEnoughMemory, NO_ARGS);
#endif

  switch(BufType)
    {
#ifndef CODER_REMOVE_SMALLBUF
    case bms_SmallBuffer:
      (*Coder)->BMS.BMSBuffer = SmallBuffer;
      break;
#endif
#ifdef CODER_USE_USERBUF
    case bms_UserBuffer:
      (*Coder)->BMS.BMSBuffer = UserBuffer;
      break;
#endif
    default:
      (*Coder)->EMS.IsAssigned = 0;
      BASEBUF_ERROR_HANDLER(*Coder, return ec_BUF_WrongBufferType, ec_BUF_WrongBufferType, NO_ARGS);
    }
  return (*Coder)->BMS.BMSBuffer.initBufWithMemory(Coder, UserMemory);
}

#endif /* !CODER_BMS_SMALLBUF && !CODER_BMS_USERBUF */
