/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.1.17494 at Mon Apr 26 09:44:53 PM CEST 2010
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __cucf_er_sdt_h
#define __cucf_er_sdt_h

#include "scttypes.h"
#include "cucf.h"

extern int ASN1EncodeOctet(SDL_Octet_String* b, tASN1TypeInfo* Type, void* val);
extern int ASN1DecodeOctet(SDL_Octet_String b, tASN1TypeInfo* Type, void* val);
extern int ASN1DecodeCoderBuf(tCoder *b, tASN1TypeInfo* Type, void* val);

/* when CustomCoderBuf is selected as ASN.1 encode/decode parameter, the following
   functions have to be defined
 
extern int ASN1EncodeCustomBuf(<buffer type> b, tASN1TypeInfo* Type, void* Val);
extern int ASN1DecodeCustomBuf(<buffer type> b, tASN1TypeInfo* Type, void* Val); 

   where <buffer type> has to be replaced by the C definition of CustomCoderBuf
   For CoderBuf these functions could be implemented as:

   int ASN1EncodeCoderBuf(tCoder* Buf,tASN1TypeInfo* Type, void* Val)
   {
     return ASN1Encode(Buf, Type, Val);
   }

   int ASN1DecodeCoderBuf(tCoder* Buf,tASN1TypeInfo* Type, void* Val)
   {
     int result;

     if (NEEDSFREE((tSDLTypeInfo *)Type->VRType))
       GenericFreeSort(val, (tSDLTypeInfo *)Type->VRType);
     result = ASN1Decode(b, Type, val);
     if (NEEDSFREE((tSDLTypeInfo *)Type->VRType))
       (void)GenericAssignSort(val, val, XASS_AR_ASS_FR,
                               (tSDLTypeInfo *)Type->VRType);
     return result;
   }

*/

#endif /* __cucf_er_sdt_h */
