/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.1.17494 at Mon Apr 26 09:44:53 PM CEST 2010
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf_er_ttcn.h"

#ifndef CODER_REMOVE_BER

int
TTCN_BEREncode(tBuffer Buf, tASN1TypeInfo *Type, GciValue* Val)
{
  return BEREncode(Buf, Type, (void*)Val);
}

int
TTCN_BERDecode(tBuffer Buf, tASN1TypeInfo *Type, tVMSULong* DecLength, GciValue** Val)
{
  int retStatus = BERDecode(Buf, Type, (void*)Val);
  *DecLength = BufGetValueLen(Buf);
  return retStatus;
}

#endif

#ifndef CODER_REMOVE_PER

typedef enum
{
  UCF_Align,
  UCF_Unalign,
  UCF_NoEndPad
} UCFEncVariant;

int
TTCN_PEREncode(tBuffer Buf, tASN1TypeInfo *Type, unsigned char EncVar, GciValue* Val)
{
  BufSetRule(Buf, (EncVar == UCF_Align) ? (er_PER | er_Aligned) : (EncVar == UCF_Unalign) ?
             (er_PER | er_Unaligned) : (er_PER | er_NoEndPad));
  return PEREncode(Buf, Type, (void*)Val);
}

int
TTCN_PERDecode(tBuffer Buf, tASN1TypeInfo *Type, unsigned char EncVar, tVMSULong* DecLength, GciValue** Val)
{
  int  retStatus;

  BufSetRule(Buf, (EncVar == UCF_Align) ? (er_PER | er_Aligned) : (EncVar == UCF_Unalign) ?
             (er_PER | er_Unaligned) : (er_PER | er_NoEndPad));
  retStatus = PERDecode(Buf, Type, (void*)Val);
  *DecLength = BufGetValueLen(Buf);
  return retStatus;
}
#endif
