/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.1.17494 at Mon Apr 26 09:44:53 PM CEST 2010
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2010.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __vms_vr_sdt_h
#define __vms_vr_sdt_h

#ifndef XENUM_TYPE
#define XENUM_TYPE int
#endif

#if defined(CODER_REAL_BASE_8)
#define CUCF_VR_SDL_REAL_BASE 8
#elif defined(CODER_REAL_BASE_16)
#define CUCF_VR_SDL_REAL_BASE 16
#elif defined(CODER_REAL_BASE_10)
#define CUCF_VR_SDL_REAL_BASE 10
#else /* CODER_REAL_BASE_2 */
#define CUCF_VR_SDL_REAL_BASE 2
#endif


/* VR SDL */

typedef XENUM_TYPE tSDLEnumerated;

struct sSDLStringComponent;
typedef struct sSDLStringComponent tSDLStringComponent;
struct sSDLStringComponent
{
  tSDLStringComponent* Suc;
  int Data;
};

typedef struct {
  tSDLStringComponent* First;
  tSDLStringComponent* Last;
  int Length;
  xbool IsAssigned;
} tSDLSequenceOf;


struct sSDLBagComponent;
typedef struct sSDLBagComponent tSDLBagComponent;
struct sSDLBagComponent
{
  tSDLBagComponent* Suc;
  long NoOfItems;
  int Data;
};

typedef struct {
  tSDLBagComponent* First;
  tSDLBagComponent* Last;
  int Length;
  xbool IsAssigned;
} tSDLSetOf;



/**************************************************************************************************/

#define VR_BOOLEAN(sdl_typeinfo) \
sdl_typeinfo

#define VR_NULL(sdl_typeinfo) \
sdl_typeinfo

#define VR_OBJECT_IDENTIFIER(sdl_typeinfo) \
sdl_typeinfo

#define VR_REAL(sdl_typeinfo) \
sdl_typeinfo

#define VR_INTEGER(sdl_typeinfo) \
sdl_typeinfo

#define VR_BIT_STRING(sdl_typeinfo) \
sdl_typeinfo

#define VR_OCTET_STRING(sdl_typeinfo) \
sdl_typeinfo

#define VR_NumericString(sdl_typeinfo) \
sdl_typeinfo

#define VR_PrintableString(sdl_typeinfo) \
sdl_typeinfo

#define VR_IA5String(sdl_typeinfo) \
sdl_typeinfo

#define VR_VisibleString(sdl_typeinfo) \
sdl_typeinfo

#define VR_UTCTime(sdl_typeinfo) \
sdl_typeinfo

#define VR_GeneralizedTime(sdl_typeinfo) \
sdl_typeinfo

#define VR_ENUMERATED(sdl_typeinfo) \
sdl_typeinfo

#define VR_SEQUENCE(sdl_typeinfo) \
sdl_typeinfo

#define VR_SET(sdl_typeinfo) \
sdl_typeinfo

#define VR_SEQUENCE_OF(sdl_typeinfo) \
sdl_typeinfo

#define VR_SET_OF(sdl_typeinfo) \
sdl_typeinfo

#define VR_CHOICE(sdl_typeinfo) \
sdl_typeinfo

#define VR_DEFINED(sdl_typeinfo) \
sdl_typeinfo

#define VR_TAGGED(sdl_typeinfo) \
sdl_typeinfo

#define VR_OPEN_ID(sdl_typeinfo) \
sdl_typeinfo

#define VR_OPEN(sdl_typeinfo) \
sdl_typeinfo

/**************************************************************************************************/
/**************************************************************************************************/

#define VMSFreeString(Coder, String) \
  if (String.IsAssigned == 0 && String.Length > 0) \
      CUCF_FREE(String.Value, String.Length, 0)

/**************************************************************************************************/
/**************************************************************************************************/

#define VMSGetValue(Coder, InVal, TypeInfo, OutVal) \
  OutVal = InVal

#define VMSSetValue(Coder, OutVal, TypeInfo, InVal) \
  { OutVal = InVal; \
    SDLFinalizeValue(Coder, TypeInfo, OutVal); }

/**************************************************************************************************/

#define VMSGetBOOLEAN(Coder, InVal, TypeInfo, OutBool) \
  OutBool = (tVMSBoolean)*(SDL_Boolean*)InVal

#define VMSSetBOOLEAN(Coder, OutVal, TypeInfo, InBool) \
  *(SDL_Boolean*)OutVal = InBool ? SDL_True : SDL_False

/**************************************************************************************************/

#define VMSGetNULL(Coder, InVal, TypeInfo, OutNull)

#define VMSSetNULL(Coder, OutVal, TypeInfo, InNull) \
  *(SDL_Null*)OutVal = SDL_NullValue

/**************************************************************************************************/

#define VMSInitOBJECT_IDENTIFIER(Coder, OutVal, TypeInfo) \
  memset(OutVal, 0, sizeof(SDL_Object_Identifier))

#define VMSGetSizeOBJECT_IDENTIFIER(Coder, InVal, TypeInfo, OutSize) \
  OutSize = (tVMSULong)((SDL_Object_Identifier*)InVal)->Length;

#define VMSGetComponentOBJECT_IDENTIFIER(Coder, InVal, TypeInfo, InIndex, OutComponent) \
{ \
  register SDL_Object_Identifier_yrec* __CurrItem = ((SDL_Object_Identifier*)InVal)->First; \
  register tVMSULong __CurrIndex = 0; \
  while (__CurrItem != NULL) \
    { \
      if (__CurrIndex == InIndex) \
        { \
          OutComponent = (tVMSObjId_Component)__CurrItem->Data; \
          break; \
        } \
      __CurrIndex++; \
      __CurrItem = __CurrItem->Suc; \
    } \
}

#define VMSSetComponentOBJECT_IDENTIFIER(Coder, OutVal, TypeInfo, InComponent) \
  { \
    SDL_Object_Identifier_yrec* __CurrItem = \
      (SDL_Object_Identifier_yrec*)CUCF_ALLOC(sizeof(SDL_Object_Identifier_yrec), 0); \
    __CurrItem->Data = (SDL_Natural)InComponent; \
    __CurrItem->Suc = NULL; \
    if (((SDL_Object_Identifier*)OutVal)->First == NULL) \
      { \
        ((SDL_Object_Identifier*)OutVal)->First = __CurrItem; \
        ((SDL_Object_Identifier*)OutVal)->Length = 1; \
      } \
    else \
      { \
        ((SDL_Object_Identifier*)OutVal)->Last->Suc = __CurrItem; \
        ((SDL_Object_Identifier*)OutVal)->Length++; \
      } \
    ((SDL_Object_Identifier*)OutVal)->Last = __CurrItem; \
    ((SDL_Object_Identifier*)OutVal)->IsAssigned = 8; \
  }

/**************************************************************************************************/

#define VMSGetREAL(Coder, InVal, TypeInfo, OutReal) \
  if (*(SDL_Real*)InVal == 0.0) \
    { \
      OutReal.Kind = rk_Zero; \
      OutReal.Mantissa = 0; \
      OutReal.Base = 0; \
      OutReal.Exponent = 0; \
    } \
  else if (*((SDL_Real*)InVal) == MINUS_INFINITY) \
    { \
      OutReal.Kind = rk_MINUS_INFINITY; \
      OutReal.Mantissa = 0; \
      OutReal.Base = 0; \
      OutReal.Exponent = 0; \
    } \
  else if (*((SDL_Real*)InVal) == PLUS_INFINITY) \
    { \
      OutReal.Kind = rk_PLUS_INFINITY; \
      OutReal.Mantissa = 0; \
      OutReal.Base = 0; \
      OutReal.Exponent = 0; \
    } \
  else \
    { \
      register double value = *((SDL_Real*)InVal); \
      register tVMSULong base = CUCF_VR_SDL_REAL_BASE; \
      register double maxmantissa = (double)LONG_MAX; \
      register long exponent = 0; \
      short int sign = 1; \
      if (value < 0) \
        { \
          value = -value; \
          sign = -1; \
        } \
      if (value < maxmantissa) \
        { \
          register double value2 = value * base; \
          register double remainder; \
          while (value2 < maxmantissa) \
            { \
              value = value2; \
              exponent--; \
              value2 *= base; \
              remainder = value - (tVMSULong)value; \
              if (remainder == 0) \
                { \
                  break; \
                } \
            } \
        } \
      else \
        { \
          while (value > maxmantissa) \
            { \
              value /= base; \
              exponent++; \
            } \
        } \
      OutReal.Kind = rk_Value; \
      OutReal.Mantissa = (tVMSReal_Mantissa)sign * (tVMSReal_Mantissa)value; \
      OutReal.Base = (tVMSReal_Base)base; \
      OutReal.Exponent = (tVMSReal_Exponent)exponent; \
    }

#define VMSSetREAL(Coder, OutVal, TypeInfo, InReal) \
  if (InReal.Kind == rk_Zero) \
    { \
      *(SDL_Real*)OutVal = 0.0; \
    } \
  else if (InReal.Kind == rk_MINUS_INFINITY) \
    { \
      *(SDL_Real*)OutVal = MINUS_INFINITY; \
    } \
  else if (InReal.Kind == rk_PLUS_INFINITY) \
    { \
      *(SDL_Real*)OutVal = PLUS_INFINITY; \
    } \
  else \
    { \
      *(SDL_Real*)OutVal = (SDL_Real)InReal.Mantissa * \
                           (SDL_Real)pow((double)InReal.Base, \
                                         (double)InReal.Exponent); \
    }

/**************************************************************************************************/

#define VMSGetINTEGER(Coder, InVal, TypeInfo, OutInt) \
  OutInt = (tVMSInteger)*(SDL_Integer*)InVal

#define VMSSetINTEGER(Coder, OutVal, TypeInfo, InInt) \
  *(SDL_Integer*)OutVal = (SDL_Integer)InInt


/**************************************************************************************************/

#define VMSAllocBIT_STRING(Coder, IOString, OCurrPtr, ILength) \
if (IOString.Value == NULL) \
  { \
    IOString.Value = (tVMSString_Value)CUCF_ALLOC(ILength, 0); \
    IOString.Length = ILength; \
    OCurrPtr = IOString.Value; \
  } \
else \
  { \
    tVMSString_Value __tmp_val = IOString.Value; \
    IOString.Value = (tVMSString_Value)CUCF_ALLOC(IOString.Length + ILength, 0); \
    memcpy(IOString.Value, __tmp_val, IOString.Length); \
    CUCF_FREE(__tmp_val, IOString.Length, 0); \
    OCurrPtr = IOString.Value + IOString.Length; \
    IOString.Length += ILength; \
  }


#define VMSGetLengthBIT_STRING(Coder, InVal, TypeInfo, OutString) \
  OutString.Length = (tVMSULong)((SDL_Bit_String*)InVal)->Length

#define VMSGetOctetBIT_STRING(Coder, IOStringVal, InRealSize, OutByte) \
  { \
    unsigned char __i; \
    for ((OutByte) = 0, __i = 0; __i < InRealSize; __i++, IOStringVal++) \
      (OutByte) |= (unsigned char)(*IOStringVal << (7 - __i)); \
  }

#define VMSPutOctetBIT_STRING(Coder, IOCurrPtr, IByte, ISize) \
{ \
  unsigned char __i; \
  for (__i = 0; __i < ISize; __i++, IOCurrPtr++) \
    *IOCurrPtr = (unsigned char)(((IByte) >> (7 - __i)) & 0x1); \
}

#define VMSGetBIT_STRING(Coder, InVal, TypeInfo, OutString) \
  { \
    OutString.Value = (tVMSString_Value)((SDL_Bit_String*)InVal)->Bits; \
    OutString.Length = (tVMSULong)((SDL_Bit_String*)InVal)->Length; \
    OutString.IsAssigned = 1; \
  }

#define VMSSetBIT_STRING(Coder, OVal, TypeInfo, IString) \
IString.IsAssigned = 1; \
if (IString.Length == 0) \
  memset(OVal, 0, sizeof(SDL_Bit_String)); \
else \
  { \
    ((SDL_Bit_String*)OVal)->Bits = IString.Value; \
    ((SDL_Bit_String*)OVal)->Length = IString.Length; \
    ((SDL_Bit_String*)OVal)->IsAssigned = 8; \
  }

#define VMSFreeBitString(Coder, IString) VMSFreeString(Coder, IString)

/**************************************************************************************************/

#define VMSAllocOCTET_STRING(Coder, IOString, OCurrPtr, ILength) \
if (IOString.Value == NULL) \
  { \
    IOString.Value = (tVMSString_Value)CUCF_ALLOC(ILength , 0); \
    IOString.Length = ILength; \
    OCurrPtr = IOString.Value; \
  } \
else \
  { \
    tVMSString_Value __tmp_val; \
    __tmp_val = (tVMSString_Value)CUCF_ALLOC(IOString.Length + ILength, 0); \
    memcpy(__tmp_val, IOString.Value, IOString.Length); \
    CUCF_FREE(IOString.Value, IOString.Length, 0); \
    IOString.Value = __tmp_val; \
    OCurrPtr = IOString.Value + IOString.Length; \
    IOString.Length += ILength; \
  }

#define VMSGetLengthOCTET_STRING(Coder, InVal, TypeInfo, OutString) \
  OutString.Length = (tVMSULong)((SDL_Octet_String*)InVal)->Length

#define VMSGetOCTET_STRING(Coder, InVal, TypeInfo, OutString) \
{ OutString.Value = (tVMSString_Value)((SDL_Octet_String*)InVal)->Bits; \
  OutString.Length = (tVMSULong)((SDL_Octet_String*)InVal)->Length; \
  OutString.IsAssigned = 1; }

#define VMSSetOCTET_STRING(Coder, OVal, TypeInfo, IString) \
IString.IsAssigned = 1; \
if (IString.Length == 0) \
  memset(OVal, 0, sizeof(SDL_Bit_String)); \
else \
  { \
    ((SDL_Bit_String*)OVal)->Bits = IString.Value; \
    ((SDL_Bit_String*)OVal)->Length = IString.Length; \
    ((SDL_Bit_String*)OVal)->IsAssigned = 8; \
  }

#define VMSFreeOctetString(Coder, IString) VMSFreeString(Coder, IString)

/**************************************************************************************************/

#define VMSAllocCHARACTER_STRING(Coder, IOString, OCurrPtr, ILength) \
if (IOString.Value == NULL) \
  { \
    IOString.Value = (tVMSString_Value)CUCF_ALLOC(ILength + 2, 0); \
    *(tVMSString_Value)(IOString.Value) = 'V'; \
    IOString.Value = (tVMSString_Value)(IOString.Value) + 1; \
    IOString.Length = ILength; \
    OCurrPtr = (tVMSString_Value)(IOString.Value); \
  } \
else \
  { \
    tVMSString_Value __tmp_val = (tVMSString_Value)(IOString.Value) - 1; \
    IOString.Value = (tVMSString_Value)CUCF_ALLOC(IOString.Length + Length + 2, 0); \
    memcpy((tVMSString_Value)(IOString.Value), __tmp_val, IOString.Length); \
    CUCF_FREE(__tmp_val, IOString.Length + 2, 0); \
    IOString.Value = (tVMSString_Value)(IOString.Value) + 1; \
    CurrStrVal = (tVMSString_Value)(IOString.Value) + IOString.Length; \
    IOString.Length += Length; \
  }

#define VMSFreeCharString(Coder, IString) VMSFreeString(Coder, IString)

/**************************************************************************************************/

#define VMSGetLengthNumericString(Coder, InVal, TypeInfo, OutString) \
  OutString.Length = (tVMSULong)strlen(*(SDL_Charstring*)InVal) - 1

#define VMSGetNumericString(Coder, InVal, TypeInfo, OutString) \
  { \
    OutString.Value = (tVMSString_Value)*(SDL_Charstring*)InVal + 1; \
    OutString.Length = (tVMSULong)strlen(*(SDL_Charstring*)InVal) - 1; \
    OutString.IsAssigned = 1; \
  }

#define VMSSetNumericString(Coder, OutVal, TypeInfo, InString) \
if (InString.Length == 0) \
  { \
    *(SDL_Charstring*)OutVal = (SDL_Charstring)CUCF_ALLOC(InString.Length + 2, 0); \
    **(SDL_Charstring*)OutVal = 'V'; \
    *(*(SDL_Charstring*)OutVal + 1) = '\0'; \
    InString.IsAssigned = 0; \
  } \
else \
  { \
    *(InString.Value + InString.Length) = '\0'; \
    *(SDL_Charstring*)OutVal = (SDL_Charstring)(InString.Value - 1); \
    InString.IsAssigned = 1; \
  }

/**************************************************************************************************/

#define VMSGetLengthPrintableString(Coder, InVal, TypeInfo, OutString) \
  VMSGetLengthNumericString(Coder, InVal, TypeInfo, OutString)

#define VMSGetPrintableString(Coder, InVal, TypeInfo, OutString) \
  VMSGetNumericString(Coder, InVal, TypeInfo, OutString)

#define VMSSetPrintableString(Coder, OutVal, TypeInfo, InString) \
  VMSSetNumericString(Coder, OutVal, TypeInfo, InString)

/**************************************************************************************************/

#define VMSGetLengthIA5String(Coder, InVal, TypeInfo, OutString) \
  VMSGetLengthNumericString(Coder, InVal, TypeInfo, OutString)

#define VMSGetIA5String(Coder, InVal, TypeInfo, OutString) \
  VMSGetNumericString(Coder, InVal, TypeInfo, OutString)

#define VMSSetIA5String(Coder, OutVal, TypeInfo, InString) \
  VMSSetNumericString(Coder, OutVal, TypeInfo, InString)

/**************************************************************************************************/

#define VMSGetLengthVisibleString(Coder, InVal, TypeInfo, OutString) \
  VMSGetLengthNumericString(Coder, InVal, TypeInfo, OutString)

#define VMSGetVisibleString(Coder, InVal, TypeInfo, OutString) \
  VMSGetNumericString(Coder, InVal, TypeInfo, OutString)

#define VMSSetVisibleString(Coder, OutVal, TypeInfo, InString) \
  VMSSetNumericString(Coder, OutVal, TypeInfo, InString)

/**************************************************************************************************/

#define VMSGetLengthUTCTime(Coder, InVal, TypeInfo, OutString) \
  VMSGetLengthNumericString(Coder, InVal, TypeInfo, OutString)

#define VMSGetUTCTime(Coder, InVal, TypeInfo, OutString) \
  VMSGetNumericString(Coder, InVal, TypeInfo, OutString)

#define VMSSetUTCTime(Coder, OutVal, TypeInfo, InString) \
  VMSSetNumericString(Coder, OutVal, TypeInfo, InString)

/**************************************************************************************************/

#define VMSGetLengthGeneralizedTime(Coder, InVal, TypeInfo, OutString) \
  VMSGetLengthNumericString(Coder, InVal, TypeInfo, OutString)

#define VMSGetGeneralizedTime(Coder, InVal, TypeInfo, OutString) \
  VMSGetNumericString(Coder, InVal, TypeInfo, OutString)

#define VMSSetGeneralizedTime(Coder, OutVal, TypeInfo, InString) \
  VMSSetNumericString(Coder, OutVal, TypeInfo, InString)

/**************************************************************************************************/

#define VMSGetIndexENUMERATED(Coder, InVal, TypeInfo, OutIndex) \
  OutIndex = (tVMSEnumerated_Index)*(tSDLEnumerated*)InVal

#define VMSSetIndexENUMERATED(Coder, OutVal, TypeInfo, InIndex) \
  *(tSDLEnumerated*)OutVal = (tSDLEnumerated)InIndex

#define VMSGetValueENUMERATED(Coder, InVal, TypeInfo, OutValue) \
  { \
    tVMSEnumerated_Index SDLIndex = (tVMSEnumerated_Index)*(tSDLEnumerated*)InVal; \
    OutValue = ((tASN1Enumerated*)TypeInfo)->Items[SDLIndex].Value; \
  }

#define VMSSetValueENUMERATED(Coder, OutVal, TypeInfo, InValue) \
  { \
    register CODER_NumOf_TYPE __NumOfItems = ((tASN1Enumerated*)TypeInfo)->NumOfItems; \
    register CODER_NumOf_TYPE __CurrIndex; \
    for (__CurrIndex = 0; __CurrIndex < __NumOfItems; __CurrIndex++) \
      { \
        if (InValue == ((tASN1Enumerated*)TypeInfo)->Items[__CurrIndex].Value) \
          { \
            *(tSDLEnumerated*)OutVal = (tSDLEnumerated)__CurrIndex; \
            break; \
          } \
      } \
  }

/**************************************************************************************************/

#define VMSGetComponentSEQUENCE(Coder, InVal, TypeInfo, InCompInfo, OutComponent) \
  { \
    tSDLStructInfo* Sort = (tSDLStructInfo*)(((tASN1Sequence*)TypeInfo)->VRType); \
    OutComponent = (void*)((char*)InVal + Sort->Components[InCompInfo->Index].Offset); \
  }

#define VMSGetOptionalComponentSEQUENCE(Coder, InVal, TypeInfo, InCompInfo, OutComponent) \
  { \
    tSDLStructInfo* Sort = (tSDLStructInfo*)(((tASN1Sequence*)TypeInfo)->VRType); \
    if (*(SDL_Boolean*)((char*)InVal + Sort->Components[InCompInfo->Index].ExtraInfo->OffsetPresent) == SDL_True) \
      OutComponent = (void*)((char*)InVal + Sort->Components[InCompInfo->Index].Offset); \
    else \
      OutComponent = NULL; \
  }

#define VMSGetDefaultComponentSEQUENCE(Coder, InVal, TypeInfo, InCompInfo, OutComponent) \
  { \
    tSDLStructInfo* Sort = (tSDLStructInfo*)(((tASN1Sequence*)TypeInfo)->VRType); \
    if (*(SDL_Boolean*)((char*)InVal + Sort->Components[InCompInfo->Index].ExtraInfo->OffsetPresent) == SDL_True) \
      OutComponent = (void*)((char*)InVal + Sort->Components[InCompInfo->Index].Offset); \
    else \
      OutComponent = NULL; \
  }

#define VMSInitSEQUENCE(Coder, OutVal, TypeInfo) \
  { \
    tSDLStructInfo* Sort = (tSDLStructInfo*)(((tASN1Sequence*)TypeInfo)->VRType); \
    memset(OutVal, 0, Sort->SortSize); \
  }

#define VMSInitPresentOptionalComponentSEQUENCE(Coder, OutVal, TypeInfo, InCompInfo) \
  { \
    tSDLStructInfo* Sort = (tSDLStructInfo*)(((tASN1Sequence*)TypeInfo)->VRType); \
    *((SDL_Boolean*)((char*)OutVal + \
      Sort->Components[InCompInfo->Index].ExtraInfo->OffsetPresent)) = SDL_True; \
  }

#define VMSInitAbsentOptionalComponentSEQUENCE(Coder, OutVal, TypeInfo, InCompInfo) \
  { \
    tSDLStructInfo* Sort = (tSDLStructInfo*)(((tASN1Sequence*)TypeInfo)->VRType); \
    *((SDL_Boolean*)((char*)OutVal + \
      Sort->Components[InCompInfo->Index].ExtraInfo->OffsetPresent)) = SDL_False; \
  }

#define VMSInitPresentDefaultComponentSEQUENCE(Coder, OutVal, TypeInfo, InCompInfo) \
  { \
    tSDLStructInfo* Sort = (tSDLStructInfo*)(((tASN1Sequence*)TypeInfo)->VRType); \
    *((SDL_Boolean*)((char*)OutVal + \
      Sort->Components[InCompInfo->Index].ExtraInfo->OffsetPresent)) = SDL_True; \
  }

#define VMSInitAbsentDefaultComponentSEQUENCE(Coder, OutVal, TypeInfo, InCompInfo) \
  { \
    tSDLStructInfo* Sort = (tSDLStructInfo*)(((tASN1Sequence*)TypeInfo)->VRType); \
    *((SDL_Boolean*)((char*)OutVal + \
      Sort->Components[InCompInfo->Index].ExtraInfo->OffsetPresent)) = SDL_False; \
    GenericAssignSort( \
      (void *)((char*)OutVal + Sort->Components[InCompInfo->Index].Offset), \
      Sort->Components[InCompInfo->Index].ExtraInfo->DefaultValue, \
      XASS_MR_ASS_NF, \
      Sort->Components[InCompInfo->Index].CompSort); \
  }

/**************************************************************************************************/

#define VMSGetComponentSET(Coder, InVal, TypeInfo, InCompInfo, OutComponent) \
  VMSGetComponentSEQUENCE(Coder, InVal, TypeInfo, InCompInfo, OutComponent)

#define VMSGetOptionalComponentSET(Coder, InVal, TypeInfo, InCompInfo, OutComponent) \
  VMSGetOptionalComponentSEQUENCE(Coder, InVal, TypeInfo, InCompInfo, OutComponent)

#define VMSGetDefaultComponentSET(Coder, InVal, TypeInfo, InCompInfo, OutComponent) \
  VMSGetDefaultComponentSEQUENCE(Coder, InVal, TypeInfo, InCompInfo, OutComponent)

#define VMSInitSET(Coder, OutVal, TypeInfo) \
  VMSInitSEQUENCE(Coder, OutVal, TypeInfo)

#define VMSInitPresentOptionalComponentSET(Coder, OutVal, TypeInfo, InCompInfo) \
  VMSInitPresentOptionalComponentSEQUENCE(Coder, OutVal, TypeInfo, InCompInfo)

#define VMSInitAbsentOptionalComponentSET(Coder, OutVal, TypeInfo, InCompInfo) \
  VMSInitAbsentOptionalComponentSEQUENCE(Coder, OutVal, TypeInfo, InCompInfo)

#define VMSInitPresentDefaultComponentSET(Coder, OutVal, TypeInfo, InCompInfo) \
  VMSInitPresentDefaultComponentSEQUENCE(Coder, OutVal, TypeInfo, InCompInfo)

#define VMSInitAbsentDefaultComponentSET(Coder, OutVal, TypeInfo, InCompInfo) \
  VMSInitAbsentDefaultComponentSEQUENCE(Coder, OutVal, TypeInfo, InCompInfo)

/**************************************************************************************************/

#define VMSInitSEQUENCE_OF(Coder, OutVal, TypeInfo) \
  { \
    tSDLTypeInfo* Sort = (tSDLTypeInfo*)(TypeInfo->VRType); \
    memset(OutVal, 0, Sort->SortSize); \
  }

#define VMSInitComponentSEQUENCE_OF(Coder, InVal, TypeInfo, InIndex, OutComponent) \
  { \
    tSDLTypeInfo* Sort = (tSDLTypeInfo*)(TypeInfo->VRType); \
    switch (Sort->TypeClass) \
      { \
      case type_SDL_LString: \
        (*(int*)InVal)++; \
        OutComponent = (void*)((char*)InVal + ((tSDLLStringInfo *)Sort)->DataOffset + \
                               InIndex * ((tSDLLStringInfo*)Sort)->CompSort->SortSize); \
        break; \
      case type_SDL_String: \
        { \
          tSDLStringComponent* __CurrItem = (tSDLStringComponent*)CUCF_ALLOC(((tSDLGenListInfo*)Sort)->CompSort->SortSize + \
                                                                           sizeof(tSDLStringComponent) - sizeof(int), 0); \
          __CurrItem->Suc = NULL; \
          memset((void*)&(__CurrItem->Data), 0, ((tSDLGenListInfo*)Sort)->CompSort->SortSize); \
          if (((tSDLSequenceOf*)InVal)->First == NULL) \
            { \
              ((tSDLSequenceOf*)InVal)->First = __CurrItem; \
              ((tSDLSequenceOf*)InVal)->Length = 1; \
            } \
          else \
            { \
              ((tSDLSequenceOf*)InVal)->Last->Suc = __CurrItem; \
              ((tSDLSequenceOf*)InVal)->Length++; \
            } \
          ((tSDLSequenceOf*)InVal)->Last = __CurrItem; \
          OutComponent = (void*)&(__CurrItem->Data); \
          ((tSDLSequenceOf*)InVal)->IsAssigned = 8; \
          break; \
        } \
      default: \
        INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, \
                               ERR_ARG(__FILE__) ERR_ARG(__LINE__)); \
      } \
  }

#define VMSGetSizeSEQUENCE_OF(Coder, InVal, TypeInfo, OutSize) \
  { \
    tSDLTypeInfo* Sort = (tSDLTypeInfo*)(TypeInfo->VRType); \
    switch (Sort->TypeClass) \
      { \
      case type_SDL_LString: \
        OutSize = *(int*)InVal; \
        break; \
      case type_SDL_String: \
        OutSize = (tVMSULong)((tSDLSequenceOf*)InVal)->Length; \
        break; \
      default: \
        INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, \
                               ERR_ARG(__FILE__) ERR_ARG(__LINE__)); \
      } \
  }

#define VMSGetComponentSEQUENCE_OF(Coder, InVal, TypeInfo, InIndex, OutComponent) \
  { \
    tSDLTypeInfo* Sort = (tSDLTypeInfo*)(TypeInfo->VRType); \
    switch (Sort->TypeClass) \
      { \
      case type_SDL_LString: \
        OutComponent = (void*)((char*)InVal + ((tSDLLStringInfo *)Sort)->DataOffset + \
                               InIndex * ((tSDLLStringInfo *)Sort)->CompSort->SortSize); \
        break; \
      case type_SDL_String: \
        { \
          register tSDLStringComponent* __CurrItem = \
            ((tSDLSequenceOf*)InVal)->First; \
          register tVMSULong __CurrIndex = 0; \
          while (__CurrItem != NULL) \
            { \
              if (__CurrIndex == InIndex) \
                { \
                  OutComponent = (void*)&(__CurrItem->Data); \
                  break; \
                } \
              __CurrIndex++; \
              __CurrItem = __CurrItem->Suc; \
            } \
        } \
        break; \
      default: \
        INTERNAL_ERROR_HANDLER(Coder, ec_INT_InternalError, \
                               ERR_ARG(__FILE__) ERR_ARG(__LINE__)); \
      } \
  }

#define VMSSetComponentSEQUENCE_OF(Coder, OutVal, TypeInfo, InIndex, InComponent)

/**************************************************************************************************/

#define VMSInitSET_OF(Coder, OutVal, TypeInfo) \
  memset(OutVal, 0, sizeof(tSDLSetOf))

#define VMSInitComponentSET_OF(Coder, InVal, TypeInfo, OutComponent) \
  { \
    tSDLTypeInfo* Sort = (tSDLTypeInfo*)(TypeInfo->VRType); \
    tSDLBagComponent* __CurrItem = (tSDLBagComponent*)CUCF_ALLOC(((tSDLGenListInfo*)Sort)->CompSort->SortSize + \
      sizeof(tSDLBagComponent) - sizeof(int), 0); \
    __CurrItem->NoOfItems = 1; \
    __CurrItem->Suc = NULL; \
    memset((void*)&(__CurrItem->Data), 0, ((tSDLGenListInfo*)Sort)->CompSort->SortSize); \
    if (((tSDLSetOf*)InVal)->First == NULL) \
      { \
        ((tSDLSetOf*)InVal)->First = __CurrItem; \
        ((tSDLSetOf*)InVal)->Length = 1; \
      } \
    else \
      { \
        ((tSDLSetOf*)InVal)->Last->Suc = __CurrItem; \
        ((tSDLSetOf*)InVal)->Length++; \
      } \
    ((tSDLSetOf*)InVal)->Last = __CurrItem; \
    OutComponent = (void*)&(__CurrItem->Data); \
  }

#define VMSGetSizeSET_OF(Coder, InVal, TypeInfo, OutSize) \
  OutSize = (tVMSULong)((tSDLSetOf*)InVal)->Length;

#define VMSGetComponentSET_OF(Coder, InVal, TypeInfo, InIndex, OutComponent) \
  { \
    register tSDLBagComponent* __CurrItem = ((tSDLSetOf*)InVal)->First; \
    register tVMSULong __CurrIndex = 0; \
    register long __CurrItemNumber; \
    register char __IsFound = 0; \
    while (!__IsFound && __CurrItem != NULL) \
      { \
        for (__CurrItemNumber = 0; __CurrItemNumber < __CurrItem->NoOfItems; __CurrItemNumber++) \
          { \
            if (__CurrIndex == InIndex) \
              { \
                OutComponent = (void*)&(__CurrItem->Data); \
                __IsFound = 1; \
                break; \
              } \
            __CurrIndex++; \
          } \
        __CurrItem = __CurrItem->Suc; \
      } \
  }

#define VMSSetComponentSET_OF(Coder, OutVal, TypeInfo, InComponent)

/**************************************************************************************************/

#define VMSInitCHOICE(Coder, OutVal, TypeInfo) \
  { \
    tSDLChoiceInfo* Sort = (tSDLChoiceInfo*)(((tASN1Choice*)TypeInfo)->VRType); \
    memset(OutVal, 0, Sort->SortSize); \
  }

#define VMSGetAlternativeCHOICE(Coder, InVal, TypeInfo, OutAltInfo, OutAlternative) \
  { \
    tSDLChoiceInfo* Sort = (tSDLChoiceInfo*)(((tASN1Choice*)TypeInfo)->VRType); \
    tASN1Alternative* __CurrAlt = ((tASN1Choice*)TypeInfo)->Alternatives; \
    CODER_NumOf_TYPE __SDLIndex = (CODER_NumOf_TYPE)GenericGetValue(Sort->TagSortSize, InVal); \
    CODER_NumOf_TYPE __NumOfAlts = ((tASN1Choice*)TypeInfo)->NumOfAlts; \
    while (__NumOfAlts > 0) \
      { \
        if ((__CurrAlt->Type != ct_Absent) && (__CurrAlt->Index == __SDLIndex)) \
          { \
            OutAltInfo = __CurrAlt; \
            break; \
          } \
        __CurrAlt++; \
        __NumOfAlts--; \
      } \
    OutAlternative = (void*)((char*)InVal + Sort->OffsetToUnion); \
  }

#define VMSSetAlternativeCHOICE(Coder, OutVal, TypeInfo, InAltInfo, OutAlternative) \
  { \
    tSDLChoiceInfo* Sort = (tSDLChoiceInfo*)(((tASN1Choice*)TypeInfo)->VRType); \
    GenericSetValue(Sort->TagSortSize, OutVal, (int)InAltInfo->Index); \
    OutAlternative = (void*)((char*)OutVal + Sort->OffsetToUnion); \
  }

/**************************************************************************************************/

#define VMSInitOPEN(Coder, OutVal, TypeInfo) \
  { \
    tSDLChoiceInfo* Sort = (tSDLChoiceInfo*)(((tASN1Open*)TypeInfo)->VRType); \
    memset(OutVal, 0, Sort->SortSize); \
  }

#define VMSGetObjectOPEN(Coder, InVal, TypeInfo, OutObjInfo, OutObject) \
  { \
    tSDLChoiceInfo* Sort = (tSDLChoiceInfo*)(((tASN1Open*)TypeInfo)->VRType); \
    register tASN1Object* __CurrObj = ((tASN1Open*)TypeInfo)->Objects; \
    register CODER_NumOf_TYPE __NumOfObjects = ((tASN1Open*)TypeInfo)->NumOfObjects; \
    register CODER_NumOf_TYPE __SDLIndex = (CODER_NumOf_TYPE)GenericGetValue(Sort->TagSortSize, InVal); \
    register CODER_NumOf_TYPE i; \
    for (i = 0; i < __NumOfObjects; __CurrObj++, i++) \
      { \
        if (__CurrObj->Index == __SDLIndex) \
          { \
            OutObjInfo = __CurrObj; \
            break; \
          } \
      } \
    OutObject = (void*)((char*)InVal + Sort->OffsetToUnion); \
  }

#define VMSSetObjectOPEN(Coder, OutVal, TypeInfo, InObjInfo, OutObject) \
  { \
    tSDLChoiceInfo* Sort = (tSDLChoiceInfo*)(((tASN1Open*)TypeInfo)->VRType); \
    GenericSetValue(Sort->TagSortSize, OutVal, (int)InObjInfo->Index); \
    OutObject = (void*)((char*)OutVal + Sort->OffsetToUnion); \
  }

#endif /* __vms_vr_sdt_h */
